//graph.h

#include "../list/list.h"
#include "../queue/queue.h"

struct Graph
{
	// Deklaration von Konstanten
	static const int MAX_NODE = 50;
	static const int INF      = -1;	// for BFS (infinity value)

	int n;	//anzahl Knoten
	int m;	//anzahl Kanten

	// Attribute
	List adj[MAX_NODE];		//Adjazenzlistendarstellung

	int topsortArray[MAX_NODE];	//topsort

	int d[MAX_NODE];		//bfs - Distanz
	int pred[MAX_NODE];		//bfs/dfs Vorgnger im Baum
	bool visited[MAX_NODE];		//dfs
	int dt[MAX_NODE];		//discovery time Zeitstempel
	int ft[MAX_NODE];		//finish time Zeitstempel
	int t;				// Zeitstempel fuer dfs

	public:
	
	Graph(int V, int Flag);
	//Flag = 0: generiert einen zufaelligen Graph
	//Flag = 1: der Benutzer initalisiert den Graph
	
	bool topsort();			// topologisches Sortieren
	void bfs(int s);		// Breitensuche
	void dfs();			// Tiefensuche (Aufruf)
	void dfsKern(int v);		// Tiefensuche (rekursiver Teil)
	bool is_backward_edge(int v, int w);
	bool is_forward_edge(int v, int w,const int *pred);
	bool is_cross_edge(int v, int w);

	void print() const;		// Ausgabe Graph
	void print_graphviz_notation() const; // Ausgabe Graph fr Graphviz
	void printTSArray() const;	//Ausgabe topsortArray
	void print_shortest_path(int s, int i); // Ausgabe krzester Weg fr BFS
};


